agl-selinux: pull in meta-clang
[AGL/meta-agl.git] / scripts / aglsetup.sh
1 ################################################################################
2 #
3 # The MIT License (MIT)
4 #
5 # Copyright (c) 2016 Stéphane Desneux <sdx@iot.bzh>
6 #
7 # Permission is hereby granted, free of charge, to any person obtaining a copy
8 # of this software and associated documentation files (the "Software"), to deal
9 # in the Software without restriction, including without limitation the rights
10 # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
11 # copies of the Software, and to permit persons to whom the Software is
12 # furnished to do so, subject to the following conditions:
13 #
14 # The above copyright notice and this permission notice shall be included in
15 # all copies or substantial portions of the Software.
16 #
17 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
18 # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
19 # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
20 # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
21 # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
22 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
23 # SOFTWARE.
24 #
25 ################################################################################
26
27 # detect if this script is sourced: see http://stackoverflow.com/a/38128348/6255594
28 SOURCED=0
29 if [ -n "$ZSH_EVAL_CONTEXT" ]; then
30         [[ $ZSH_EVAL_CONTEXT =~ :file$ ]] && { SOURCED=1; SOURCEDIR=$(cd $(dirname -- $0) && pwd -P); }
31 elif [ -n "$KSH_VERSION" ]; then
32         [[ "$(cd $(dirname -- $0) && pwd -P)/$(basename -- $0)" != "$(cd $(dirname -- ${.sh.file}) && pwd -P)/$(basename -- ${.sh.file})" ]] && { SOURCED=1; SOURCEDIR=$(cd $(dirname -- ${.sh.file}) && pwd -P); }
33 elif [ -n "$BASH_VERSION" ]; then
34         [[ $0 != "$BASH_SOURCE" ]] && { SOURCED=1; SOURCEDIR=$(cd $(dirname -- $BASH_SOURCE) && pwd -P); }
35 fi
36
37 if [ $SOURCED -ne 1 ]; then
38         unset SOURCED
39         unset SOURCEDIR
40         echo "Error: this script needs to be sourced in a supported shell" >&2
41         echo "Please check that the current shell is bash, zsh or ksh and run this script as '. $0 <args>'" >&2
42         exit 56
43 else
44         unset SOURCED
45         tmpfile=$(mktemp /tmp/aglsetup.XXXXXXXX)
46         $SOURCEDIR/.aglsetup_genconfig.bash -s $tmpfile "$@"
47         rc=$?
48         unset SOURCEDIR
49         if [ $rc -eq 0 ]; then
50                 source $tmpfile
51                 rc=$?
52         else
53                 echo "Error: configuration files generation failed. Environment is not ready."
54         fi
55
56         rm -f $tmpfile
57         unset tmpfile
58         return $rc
59 fi
60